package demo.action;

import java.util.List;

import javax.annotation.Resource;

import org.seasar.framework.beans.util.Beans;
import org.seasar.struts.annotation.ActionForm;
import org.seasar.struts.annotation.Execute;

import demo.dao.EmpDao;
import demo.entity.Emp;
import demo.form.EmpForm;

public class EmpAction {

    public List<Emp> empItems;

    @ActionForm
    @Resource
    protected EmpForm empForm;

    @Resource
    protected EmpDao empDao;

    @Execute(validator = false)
    public String index() {
        empItems = empDao.findAll();
        return "list.jsp";
    }

    @Execute(validator = false, urlPattern = "show/{id}")
    public String show() {
        Emp emp = empDao.findById(Integer.valueOf(empForm.id));
        Beans.copy(emp, empForm).execute();
        return "show.jsp";
    }

    @Execute(validator = false, urlPattern = "edit/{id}")
    public String edit() {
        Emp emp = empDao.findById(Integer.valueOf(empForm.id));
        Beans.copy(emp, empForm).execute();
        return "edit.jsp";
    }

    @Execute(validator = false)
    public String create() {
        return "create.jsp";
    }

    @Execute(validator = false, urlPattern = "delete/{id}/{versionNo}", redirect = true)
    public String delete() {
        Emp emp = new Emp();
        Beans.copy(empForm, emp).execute();
        empDao.delete(emp);
        return "/emp/";
    }

    @Execute(input = "create.jsp", redirect = true)
    public String insert() {
        Emp emp = new Emp();
        Beans.copy(empForm, emp).execute();
        empDao.insert(emp);
        return "/emp/";
    }

    @Execute(input = "edit.jsp", redirect = true)
    public String update() {
        Emp emp = new Emp();
        Beans.copy(empForm, emp).execute();
        empDao.update(emp);
        return "/emp/";
    }
}